// Description: a node that stores and manipulates a character string
//
//<b>notes:</b>
//<ul>
//<li> derived nodes inherit all messages from their base classes
//<li> see reset method for default settings
//</ul>
//
// Category: Math
// Author: Alex Hill
// Revision: 04/02/03
//
#include <ygNetMessages.h>
#include "String.h"

extern "C" ygNode* construct_String(const char* name,bool master) { return new String(name,master); }


String::String(const char* name,bool master) : ygNode(name,master)
    {
    setClassName("String");
    addNetMessage("data",&netString,YG_NET_STRING);
    }

String::~String(void)
    {
    }


void String::reset(void)
    {
    resetNetMessage("string");
    ygNode::reset();
    }


void String::message(const ygMessage& msg)
    {
    //set string string to be generated
    if (msg == "data")
        {
        lengthEvent();
        }
    //concatenate onto the string
    else if (msg == "concatenate")
        {
        if (msg.numArgs() == 1)
            {
            netString += msg.stringArg(0);
            lengthEvent();
            }
        else
            msg.error(name(),"(wrong number of arguments)");
        }
    else
        ygNode::message(msg);
    }

void String::lengthEvent(void)
    {
    int length = netString.length();
    ygString args;
    args = "length=";
    char val[32];
    sprintf(val,"%d",length);
    args += val;
    eventOccurred("changed",args);
    }
