#ifndef _liveVideo_h_
#define _liveVideo_h_

#include <Performer/pr/pfString.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoSet.h>
#include <Performer/pr/pfGeoState.h>
#include <Performer/pr/pfMaterial.h> 
#include <Performer/pr/pfTexture.h>
#include <Performer/pf/pfGroup.h>
#include <Performer/pf/pfNode.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pf/pfSCS.h>
#include <Performer/pfdu.h>

#include "ygString.h"
#include "ygNode.h"
#include "ygNodeDB.h"
#include "ygWorld.h"
#include "ygNetKeys.h"
#include "ygUser.h"
#include "ygSpace.h"

class liveVideo : public ygSpace 
{
    public:
           liveVideo(const char* name, bool master=true);   
           ~liveVideo();
           virtual void message(const ygMessage&);
           virtual void app(void);
           virtual void reset(void);

    protected:
           virtual void acceptNetKey(const ygString&);

    private:
           int readImageChunks();
        void checkVolume();
        struct _liveVideoPrivateData *_p;
};
 

extern "C" ygNode* construct_liveVideo(const char*,bool);
 
 
#endif



