#ifndef _ygNetMessages_h_
#define _ygNetMessages_h_

#include "ygString.h"
#include "ygMessage.h"

enum
    {
    YG_NET_STRING,
    YG_NET_INT,
    YG_NET_FLOAT,
    YG_NET_BOOL,
    YG_NET_BOOL_NEGATE,
    YG_NET_VEC2,
    YG_NET_VEC3,
    YG_NET_VEC4,
    YG_NET_VECTOR,
    YG_NET_MATRIX,
    YG_NET_COORD,
    YG_NET_STRING_ADD,
    YG_NET_STRING_DELETE,
    };

struct _ygNetMessagesMsg;

class ygNetMessages
    {
    public:
     ygNetMessages(void);
     ~ygNetMessages(void);
         void addMessage(const ygString&,void *,int);
         void addMessageMap(const ygString&,const ygString&,int);
         void resetMessage(const ygString&);
         void setNodeName(const ygString&);
         void sendMessage(const ygString&);
         void parseMessage(const ygMessage&);
         void reliableMessage(const ygString&);
         void unreliableMessage(const ygString&);
         void requestAllMessages(void);
         bool receiveMessage(const ygString&,void*);
         void dontBroadcast(const ygString&);
         void dontSave(const ygString&);
         const std::vector<ygMessage*>& getMessages(bool all=true);
         ygString* getMessageArg(const ygString&,int);
    private:
     struct _ygNetMessagesPrivateData * p_;
    };

#endif
