#ifndef _ygTransform_h_
#define _ygTransform_h_

#include <Performer/pr/pfLinMath.h>
#include <Performer/pr/pfGeoSet.h>
#include "ygNode.h"

using namespace std;

class ygTransform : public ygNode
	{
	public:
	 ygTransform(const char*,bool master=true);
	 virtual ~ygTransform(void);
	 virtual void reset(void);
	 virtual void message(const ygMessage&);
	 virtual void app(void);
	 virtual void updateDebug(void);
		 void getMatrix(pfMatrix&) const;
		 void setMatrix(pfMatrix&);
		 void setPosition(float x,float y,float z);
		 void setOrientation(float x,float y,float z);
		 void setSize(float s);
		 void setSize(float sx,float sy,float sz);
	 inline	 void setPosition(pfVec3 v) { setPosition(v[0],v[1],v[2]); }
	 inline	 void setOrientation(pfVec3 v) {setOrientation(v[0],v[1],v[2]);}
	 inline	 void setSize(pfVec3 v) { setSize(v[0],v[1],v[2]); }
	private:
	 struct _ygTransformPrivateData *p_;
		 void makeDebugGeode(void);
		 void setPosition(const ygMessage&);
		 void setOrientation(const ygMessage&);
	};


extern "C" ygNode* construct_ygTransform(const char*,bool);

#endif
